<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
    <button (click)="newRecord(modalRol)" class="btn btn-primary">
        <i class="fa fa-plus mr-2"></i>Nuevo
    </button>
    <!-- <button (click)="printPDF()" class="btn btn-danger ml-1">
        <i class="fa fa-file-pdf mr-2"></i>PDF
    </button> -->
</app-page-title>

<div class="card">
    <div class="card-body">
        <kendo-grid [data]="dataGrid" [selectable]="true" [filter]="filter" [filterable]="true"
            (filterChange)="filterChange($event)" [navigable]="true" [reorderable]="true" [resizable]="true"
            [sort]="sort" [sortable]="true" (sortChange)="sortChange($event)" [groupable]="false" [group]="groups"
            (groupChange)="groupChange($event)" (edit)="editRow($event, modalRol)" (remove)="deleteRow($event)"
            (detailExpand)="expandGrid($event)" style="height: 69vh">
            <kendo-grid-column field="cRolcod" title="Código" [filterable]="false" width="120">
            </kendo-grid-column>
            <kendo-grid-column field="cRolDesc" title="Nombre" width="250"></kendo-grid-column>
            <kendo-grid-column field="cSistema" title="Sistema" width="150">
                <ng-template kendoGridFilterMenuTemplate let-column="column" let-filter="filter"
                    let-filterService="filterService">
                    <kendo-multiselect style="width:220px" [data]="ddlSistemas" textField="cSistema"
                        valueField="cSistema" [valuePrimitive]="true" [value]="categoryFilters(filter)"
                        (valueChange)="categoryChange($event, filterService)">
                    </kendo-multiselect>
                </ng-template>
                <ng-template kendoGridCellTemplate let-dataItem>
                    {{dataItem.cSistema | uppercase }}
                </ng-template>
            </kendo-grid-column>
            <kendo-grid-column field="Inactivo" title="Inactivo" width="120">
                <ng-template kendoGridFilterCellTemplate>
                    <kendo-switch (valueChange)="switchChange($event)" offLabel="No" [checked]="checked" onLabel="Si">
                    </kendo-switch>
                </ng-template>
                <ng-template kendoGridCellTemplate let-dataItem>
                    <input type="checkbox" [checked]="dataItem.Inactivo" disabled />
                </ng-template>
            </kendo-grid-column>
            <kendo-grid-command-column title="Actions" width="190">
                <ng-template kendoGridCellTemplate let-isNew="isNew">
                    <button kendoGridEditCommand [primary]="true">Editar</button>
                    <button kendoGridRemoveCommand>Eliminar</button>
                </ng-template>
            </kendo-grid-command-column>
            <div *kendoGridDetailTemplate="let dataItem">
                <app-mantto-roles-add [data]="dataItem" (refresh)="getRoles()" (show)="openModal(modalHelp, 'lg')">
                </app-mantto-roles-add>
            </div>
        </kendo-grid>
    </div>
</div>


<ng-template #modalRol let-c="close" let-d="dismiss">
    <div class="modal-header">
        <div class="modal-title h6">
            <span *ngIf="flagEdit">Editar</span>
            <span *ngIf="!flagEdit">Nuevo</span>
            Rol de Usuario
        </div>
        <button class="close" aria-label="Close" (click)="d('Cross click')">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body">
        <form [formGroup]="myFormGroup">
            <div class="row">
                <div class="form-group col-12">
                    <label>Código</label>
                    <input type="text" class="form-control" appFocus formControlName="cRolcod" [readonly]="flagEdit">
                </div>
                <div class="form-group col-12">
                    <label>Descripción</label>
                    <input type="text" class="form-control" formControlName="cRolDesc">
                </div>
                <div class="form-group col-12">
                    <label>Sistema</label>
                    <kendo-dropdownlist [data]="ddlSistemas" [textField]="'cSistema'" [valueField]="'cSistema'"
                        [valuePrimitive]="true" formControlName="cSistema" class="w-100">
                    </kendo-dropdownlist>
                </div>
                <div class="form-group col-12" *ngIf="flagEdit">
                    <label class="w-100">Inactivo</label>
                    <kendo-switch formControlName="Inactivo" [onLabel]="'Si'" [offLabel]="'No'">
                    </kendo-switch>
                </div>
            </div>
        </form>
    </div>
    <div class="modal-footer">
        <button class="btn btn-success mr-1" [disabled]="myFormGroup.invalid" (click)="guardarForm()">
            <i class="fas fa-save mr-2"></i>Guardar
        </button>
        <button class="btn btn-secondary" (click)="c('Close click')">
            Cerrar
        </button>
    </div>
</ng-template>


<ng-template #modalHelp let-c="close" let-d="dismiss">
    <div class="modal-header">
        <div class="modal-title">
            Agregar Opción
        </div>
        <button class="close" aria-label="Close" (click)="d('Cross click')">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>

    <div class="modal-body">
        <app-mantto-roles-menu [data]="dataItemSelected" (refresh)="refreshGrid($event)">
        </app-mantto-roles-menu>
    </div>
    <div class="modal-footer">
        <button class="btn btn-secondary" (click)="c('Close click')">
            Cerrar
        </button>
    </div>
</ng-template>